commit c239267759be2cf3e1afadea86aff5ba3517d934
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Dec 14 12:02:55 2021

    c: Fix ICE on deferred pragma in unknown attribute arguments [PR103587]
    
    We ICE on the following testcase, because c_parser_balanced_token_sequence
    when encountering a deferred pragma will just use c_parser_consume_token
    which the FE doesn't allow for CPP_PRAGMA tokens (and if that wasn't
    the case, it could ICE on CPP_PRAGMA_EOL similarly).
    We don't know in what exact context the pragma appears when we don't
    know what those arguments semantically mean, so I think we should just
    skip over them, like e.g. the C++ FE does.  And, I think (/[/{ vs. )/]/}
    from outside of the pragma shouldn't be paired with those inside of
    the pragma and it doesn't seem to be necessary to check that inside of
    the pragma line itself all the paren kinds are balanced.
    
    2021-12-14  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/103587
            * c-parser.c (c_parser_balanced_token_sequence): For CPP_PRAGMA,
            consume the pragma and silently skip to the pragma eol.
    
            * gcc.dg/pr103587.c: New test.
    
    (cherry picked from commit e163dbbc4433e598cad7e6011b255d1d6ad93a3b)

diff --git a/gcc/c/c-parser.c b/gcc/c/c-parser.c
index 8897e4348a2..7690977f6b8 100644
--- a/gcc/c/c-parser.c
+++ b/gcc/c/c-parser.c
@@ -4841,6 +4841,11 @@ c_parser_balanced_token_sequence (c_parser *parser)
 	case CPP_EOF:
 	  return;
 
+	case CPP_PRAGMA:
+	  c_parser_consume_pragma (parser);
+	  c_parser_skip_to_pragma_eol (parser, false);
+	  break;
+
 	default:
 	  c_parser_consume_token (parser);
 	  break;
diff --git a/gcc/testsuite/gcc.dg/pr103587.c b/gcc/testsuite/gcc.dg/pr103587.c
new file mode 100644
index 00000000000..1cbc4d52d9d
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr103587.c
@@ -0,0 +1,7 @@
+/* PR c/103587 */
+/* { dg-do compile } */
+/* { dg-options "" } */
+
+[[foo::bar(
+#pragma GCC ivdep
+)]];	/* { dg-warning "attribute ignored" } */

